/*
 * Copyright 2010-2016 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jetbrains.kotlin.ir.expressions

import org.jetbrains.kotlin.descriptors.ValueDescriptor
import org.jetbrains.kotlin.descriptors.VariableDescriptor
import org.jetbrains.kotlin.ir.symbols.IrValueSymbol
import org.jetbrains.kotlin.ir.symbols.IrVariableSymbol

interface IrValueAccessExpression : IrDeclarationReference {
    override val descriptor: ValueDescriptor
    override val symbol: IrValueSymbol
    val origin: IrStatementOrigin?
}

interface IrGetValue : IrValueAccessExpression, IrExpressionWithCopy {
    override fun copy(): IrGetValue
}

interface IrSetVariable : IrValueAccessExpression {
    override val descriptor: VariableDescriptor
    override val symbol: IrVariableSymbol
    var value: IrExpression
}

